<!----------------------------------------------------------------------------------------------------------------------
  -- pageWrapper.vue
  --------------------------------------------------------------------------------------------------------------------->

<template>
    <div class="page-wrapper">
        <!-- Header -->
        <site-header></site-header>

        <!-- Content -->
        <b-container
            class="content"
            :fluid="fluid"
        >
            <div
                v-if="isEditingEnabled"
                class="mt-4 mb-1 mr-3 edit-link text-right"
            >
                <a
                    :href="editURL"
                    class="edit-link text-muted"
                    target="_blank"
                >
                    <fa icon="edit"></fa>
                    Edit on GitLab
                </a>
            </div>
            <b-card
                id="page-content"
                class="drop-shadow"
                :class="!isEditingEnabled ? 'mt-5' : ''"
            >
                <b-card
                    v-if="sidebar"
                    id="page-sidebar"
                    class="ml-2 mb-2 float-right drop-shadow"
                >
                    <ul class="list-unstyled mb-0">
                        <li
                            v-for="(heading, index) in page.markdownHeadings"
                            :key="index"
                            :class="`level-${ heading.level }`"
                        >
                            <saber-link :to="`#${ heading.slug }`">
                                {{ heading.text }}
                            </saber-link>
                        </li>
                    </ul>
                </b-card>
                <slot name="default"></slot>
            </b-card>
        </b-container>

        <!-- Footer -->
        <site-footer></site-footer>
    </div>
</template>

<!--------------------------------------------------------------------------------------------------------------------->

<style lang="scss" scoped>
    .page-wrapper {
        clear: both;
        .content {
            #page-sidebar {
                flex: 0 0 250px;
                min-width: 250px;
                clear: right;
                z-index: 1;

                background-color: #272B30;

                ul > li {
                    & a {
                        color: #999;
                        text-decoration: none;

                        &:hover {
                            color: #bbb;
                        }
                    }
                }

                .level-1 {
                    font-size: 1.25rem;
                    border-bottom: 1px solid #aaa;
                    margin-bottom: .5rem;

                    & a {
                        color: #eee;

                        &:hover {
                            color: #d9d9d9;
                        }
                    }
                }

                .level-2 {
                    font-size: 1rem;
                    margin-left: 0.25rem;

                    & a {
                        color: #777;

                        &:hover {
                            color: #aaa;
                        }
                    }
                }

                .level-3 {
                    font-size: 0.85rem;
                    margin-left: 0.75rem;
                }

                .level-4 {
                    font-size: 0.85rem;
                    margin-left: 1.25rem;
                }

                .level-5 {
                    font-size: 0.85rem;
                    margin-left: 1.75rem;

                    & a {
                        color: #bbb;
                        text-decoration: none;

                        &:hover {
                            color: #ddd;
                        }
                    }
                }

                .level-6 {
                    font-size: 0.85rem;
                    margin-left: 1.75rem;

                    & a {
                        color: #bbb;
                        text-decoration: none;

                        &:hover {
                            color: #ddd;
                        }
                    }
                }
            }

            .edit-link {
                font-size: 0.85rem;
            }

            #page-content {
                flex: 1 1 auto;
            }
        }
    }
</style>

<!--------------------------------------------------------------------------------------------------------------------->

<script>
//------------------------------------------------------------------------------------------------------------------

// Components
    import SiteHeader from './siteHeader.vue';
    import SiteFooter from './siteFooter.vue';

    //------------------------------------------------------------------------------------------------------------------

    export default {
        name: 'PageWrapper',
        components: {
            SiteHeader,
            SiteFooter
        },
        props: {
            page: {
                type: Object,
                default()
                {
                    return {};
                }
            },
            disableEdit: {
                type: Boolean,
                default: false
            }
        },
        computed: {
            fluid() { return !!(this.page || {}).fluid; },
            sidebar() { return !!(this.page || {}).sidebar; },
            isEditingEnabled()
            {
                // This is basically some fancy checking to make sure we handle whatever dumb crap people type in to an
                // HTML property; there's a lot of disagreement about how to handle this, but I'm pretty egalitarian.
                const editEnabled = !this.disableEdit && this.disableEdit !== '' && (`${ this.disableEdit }`).toLowerCase() !== 'true';
                return editEnabled && this.$themeConfig.enableEditing;
            },
            projectURL()
            {
                return this.$themeConfig.projectURL;
            },
            editURL()
            {
                const filename = `${ this.page.slug }.md`;
                return `${ this.projectURL }/edit/master/pages/${ filename }`;
            }
        }
    };
</script>

<!--------------------------------------------------------------------------------------------------------------------->
